# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class TLE(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, satellite_catalog_number: str=None, classification: str=None, international_designator_year: str=None, international_designator_launch_number: str=None, epoch_year: str=None, epoch_day_and_fractional: str=None, first_derivative_mean_motion: str=None, second_derivative_mean_motion: str=None, radiation_pressure_coefficient: str=None, ephemeris_type: str=None, element_set_number: str=None, checksum_line_1: str=None, inclination: str=None, right_ascension: str=None, eccentricity: str=None, argument_of_perigee: str=None, mean_anomaly: str=None, revolution_number_at_epoch: str=None, checksum_line_2: str=None, international_designator_piece_of_launch: str=None, mean_motion: str=None):  # noqa: E501
        """TLE - a model defined in Swagger

        :param satellite_catalog_number: The satellite_catalog_number of this TLE.  # noqa: E501
        :type satellite_catalog_number: str
        :param classification: The classification of this TLE.  # noqa: E501
        :type classification: str
        :param international_designator_year: The international_designator_year of this TLE.  # noqa: E501
        :type international_designator_year: str
        :param international_designator_launch_number: The international_designator_launch_number of this TLE.  # noqa: E501
        :type international_designator_launch_number: str
        :param epoch_year: The epoch_year of this TLE.  # noqa: E501
        :type epoch_year: str
        :param epoch_day_and_fractional: The epoch_day_and_fractional of this TLE.  # noqa: E501
        :type epoch_day_and_fractional: str
        :param first_derivative_mean_motion: The first_derivative_mean_motion of this TLE.  # noqa: E501
        :type first_derivative_mean_motion: str
        :param second_derivative_mean_motion: The second_derivative_mean_motion of this TLE.  # noqa: E501
        :type second_derivative_mean_motion: str
        :param radiation_pressure_coefficient: The radiation_pressure_coefficient of this TLE.  # noqa: E501
        :type radiation_pressure_coefficient: str
        :param ephemeris_type: The ephemeris_type of this TLE.  # noqa: E501
        :type ephemeris_type: str
        :param element_set_number: The element_set_number of this TLE.  # noqa: E501
        :type element_set_number: str
        :param checksum_line_1: The checksum_line_1 of this TLE.  # noqa: E501
        :type checksum_line_1: str
        :param inclination: The inclination of this TLE.  # noqa: E501
        :type inclination: str
        :param right_ascension: The right_ascension of this TLE.  # noqa: E501
        :type right_ascension: str
        :param eccentricity: The eccentricity of this TLE.  # noqa: E501
        :type eccentricity: str
        :param argument_of_perigee: The argument_of_perigee of this TLE.  # noqa: E501
        :type argument_of_perigee: str
        :param mean_anomaly: The mean_anomaly of this TLE.  # noqa: E501
        :type mean_anomaly: str
        :param revolution_number_at_epoch: The revolution_number_at_epoch of this TLE.  # noqa: E501
        :type revolution_number_at_epoch: str
        :param checksum_line_2: The checksum_line_2 of this TLE.  # noqa: E501
        :type checksum_line_2: str
        :param international_designator_piece_of_launch: The international_designator_piece_of_launch of this TLE.  # noqa: E501
        :type international_designator_piece_of_launch: str
        :param mean_motion: The mean_motion of this TLE.  # noqa: E501
        :type mean_motion: str
        """
        self.swagger_types = {
            'satellite_catalog_number': str,
            'classification': str,
            'international_designator_year': str,
            'international_designator_launch_number': str,
            'epoch_year': str,
            'epoch_day_and_fractional': str,
            'first_derivative_mean_motion': str,
            'second_derivative_mean_motion': str,
            'radiation_pressure_coefficient': str,
            'ephemeris_type': str,
            'element_set_number': str,
            'checksum_line_1': str,
            'inclination': str,
            'right_ascension': str,
            'eccentricity': str,
            'argument_of_perigee': str,
            'mean_anomaly': str,
            'revolution_number_at_epoch': str,
            'checksum_line_2': str,
            'international_designator_piece_of_launch': str,
            'mean_motion': str
        }

        self.attribute_map = {
            'satellite_catalog_number': 'satellite-catalog-number',
            'classification': 'classification',
            'international_designator_year': 'international-designator-year',
            'international_designator_launch_number': 'international-designator-launch-number',
            'epoch_year': 'epoch-year',
            'epoch_day_and_fractional': 'epoch-day-and-fractional',
            'first_derivative_mean_motion': 'first-derivative-mean-motion',
            'second_derivative_mean_motion': 'second-derivative-mean-motion',
            'radiation_pressure_coefficient': 'radiation-pressure-coefficient',
            'ephemeris_type': 'ephemeris-type',
            'element_set_number': 'element-set-number',
            'checksum_line_1': 'checksum-line-1',
            'inclination': 'inclination',
            'right_ascension': 'right-ascension',
            'eccentricity': 'eccentricity',
            'argument_of_perigee': 'argument-of-perigee',
            'mean_anomaly': 'mean-anomaly',
            'revolution_number_at_epoch': 'revolution-number-at-epoch',
            'checksum_line_2': 'checksum-line-2',
            'international_designator_piece_of_launch': 'international-designator-piece-of-launch',
            'mean_motion': 'mean-motion'
        }
        self._satellite_catalog_number = satellite_catalog_number
        self._classification = classification
        self._international_designator_year = international_designator_year
        self._international_designator_launch_number = international_designator_launch_number
        self._epoch_year = epoch_year
        self._epoch_day_and_fractional = epoch_day_and_fractional
        self._first_derivative_mean_motion = first_derivative_mean_motion
        self._second_derivative_mean_motion = second_derivative_mean_motion
        self._radiation_pressure_coefficient = radiation_pressure_coefficient
        self._ephemeris_type = ephemeris_type
        self._element_set_number = element_set_number
        self._checksum_line_1 = checksum_line_1
        self._inclination = inclination
        self._right_ascension = right_ascension
        self._eccentricity = eccentricity
        self._argument_of_perigee = argument_of_perigee
        self._mean_anomaly = mean_anomaly
        self._revolution_number_at_epoch = revolution_number_at_epoch
        self._checksum_line_2 = checksum_line_2
        self._international_designator_piece_of_launch = international_designator_piece_of_launch
        self._mean_motion = mean_motion

    @classmethod
    def from_dict(cls, dikt) -> 'TLE':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The TLE of this TLE.  # noqa: E501
        :rtype: TLE
        """
        return util.deserialize_model(dikt, cls)

    @property
    def satellite_catalog_number(self) -> str:
        """Gets the satellite_catalog_number of this TLE.


        :return: The satellite_catalog_number of this TLE.
        :rtype: str
        """
        return self._satellite_catalog_number

    @satellite_catalog_number.setter
    def satellite_catalog_number(self, satellite_catalog_number: str):
        """Sets the satellite_catalog_number of this TLE.


        :param satellite_catalog_number: The satellite_catalog_number of this TLE.
        :type satellite_catalog_number: str
        """

        self._satellite_catalog_number = satellite_catalog_number

    @property
    def classification(self) -> str:
        """Gets the classification of this TLE.


        :return: The classification of this TLE.
        :rtype: str
        """
        return self._classification

    @classification.setter
    def classification(self, classification: str):
        """Sets the classification of this TLE.


        :param classification: The classification of this TLE.
        :type classification: str
        """

        self._classification = classification

    @property
    def international_designator_year(self) -> str:
        """Gets the international_designator_year of this TLE.


        :return: The international_designator_year of this TLE.
        :rtype: str
        """
        return self._international_designator_year

    @international_designator_year.setter
    def international_designator_year(self, international_designator_year: str):
        """Sets the international_designator_year of this TLE.


        :param international_designator_year: The international_designator_year of this TLE.
        :type international_designator_year: str
        """

        self._international_designator_year = international_designator_year

    @property
    def international_designator_launch_number(self) -> str:
        """Gets the international_designator_launch_number of this TLE.


        :return: The international_designator_launch_number of this TLE.
        :rtype: str
        """
        return self._international_designator_launch_number

    @international_designator_launch_number.setter
    def international_designator_launch_number(self, international_designator_launch_number: str):
        """Sets the international_designator_launch_number of this TLE.


        :param international_designator_launch_number: The international_designator_launch_number of this TLE.
        :type international_designator_launch_number: str
        """

        self._international_designator_launch_number = international_designator_launch_number

    @property
    def epoch_year(self) -> str:
        """Gets the epoch_year of this TLE.


        :return: The epoch_year of this TLE.
        :rtype: str
        """
        return self._epoch_year

    @epoch_year.setter
    def epoch_year(self, epoch_year: str):
        """Sets the epoch_year of this TLE.


        :param epoch_year: The epoch_year of this TLE.
        :type epoch_year: str
        """

        self._epoch_year = epoch_year

    @property
    def epoch_day_and_fractional(self) -> str:
        """Gets the epoch_day_and_fractional of this TLE.


        :return: The epoch_day_and_fractional of this TLE.
        :rtype: str
        """
        return self._epoch_day_and_fractional

    @epoch_day_and_fractional.setter
    def epoch_day_and_fractional(self, epoch_day_and_fractional: str):
        """Sets the epoch_day_and_fractional of this TLE.


        :param epoch_day_and_fractional: The epoch_day_and_fractional of this TLE.
        :type epoch_day_and_fractional: str
        """

        self._epoch_day_and_fractional = epoch_day_and_fractional

    @property
    def first_derivative_mean_motion(self) -> str:
        """Gets the first_derivative_mean_motion of this TLE.


        :return: The first_derivative_mean_motion of this TLE.
        :rtype: str
        """
        return self._first_derivative_mean_motion

    @first_derivative_mean_motion.setter
    def first_derivative_mean_motion(self, first_derivative_mean_motion: str):
        """Sets the first_derivative_mean_motion of this TLE.


        :param first_derivative_mean_motion: The first_derivative_mean_motion of this TLE.
        :type first_derivative_mean_motion: str
        """

        self._first_derivative_mean_motion = first_derivative_mean_motion

    @property
    def second_derivative_mean_motion(self) -> str:
        """Gets the second_derivative_mean_motion of this TLE.


        :return: The second_derivative_mean_motion of this TLE.
        :rtype: str
        """
        return self._second_derivative_mean_motion

    @second_derivative_mean_motion.setter
    def second_derivative_mean_motion(self, second_derivative_mean_motion: str):
        """Sets the second_derivative_mean_motion of this TLE.


        :param second_derivative_mean_motion: The second_derivative_mean_motion of this TLE.
        :type second_derivative_mean_motion: str
        """

        self._second_derivative_mean_motion = second_derivative_mean_motion

    @property
    def radiation_pressure_coefficient(self) -> str:
        """Gets the radiation_pressure_coefficient of this TLE.


        :return: The radiation_pressure_coefficient of this TLE.
        :rtype: str
        """
        return self._radiation_pressure_coefficient

    @radiation_pressure_coefficient.setter
    def radiation_pressure_coefficient(self, radiation_pressure_coefficient: str):
        """Sets the radiation_pressure_coefficient of this TLE.


        :param radiation_pressure_coefficient: The radiation_pressure_coefficient of this TLE.
        :type radiation_pressure_coefficient: str
        """

        self._radiation_pressure_coefficient = radiation_pressure_coefficient

    @property
    def ephemeris_type(self) -> str:
        """Gets the ephemeris_type of this TLE.


        :return: The ephemeris_type of this TLE.
        :rtype: str
        """
        return self._ephemeris_type

    @ephemeris_type.setter
    def ephemeris_type(self, ephemeris_type: str):
        """Sets the ephemeris_type of this TLE.


        :param ephemeris_type: The ephemeris_type of this TLE.
        :type ephemeris_type: str
        """

        self._ephemeris_type = ephemeris_type

    @property
    def element_set_number(self) -> str:
        """Gets the element_set_number of this TLE.


        :return: The element_set_number of this TLE.
        :rtype: str
        """
        return self._element_set_number

    @element_set_number.setter
    def element_set_number(self, element_set_number: str):
        """Sets the element_set_number of this TLE.


        :param element_set_number: The element_set_number of this TLE.
        :type element_set_number: str
        """

        self._element_set_number = element_set_number

    @property
    def checksum_line_1(self) -> str:
        """Gets the checksum_line_1 of this TLE.


        :return: The checksum_line_1 of this TLE.
        :rtype: str
        """
        return self._checksum_line_1

    @checksum_line_1.setter
    def checksum_line_1(self, checksum_line_1: str):
        """Sets the checksum_line_1 of this TLE.


        :param checksum_line_1: The checksum_line_1 of this TLE.
        :type checksum_line_1: str
        """

        self._checksum_line_1 = checksum_line_1

    @property
    def inclination(self) -> str:
        """Gets the inclination of this TLE.


        :return: The inclination of this TLE.
        :rtype: str
        """
        return self._inclination

    @inclination.setter
    def inclination(self, inclination: str):
        """Sets the inclination of this TLE.


        :param inclination: The inclination of this TLE.
        :type inclination: str
        """

        self._inclination = inclination

    @property
    def right_ascension(self) -> str:
        """Gets the right_ascension of this TLE.


        :return: The right_ascension of this TLE.
        :rtype: str
        """
        return self._right_ascension

    @right_ascension.setter
    def right_ascension(self, right_ascension: str):
        """Sets the right_ascension of this TLE.


        :param right_ascension: The right_ascension of this TLE.
        :type right_ascension: str
        """

        self._right_ascension = right_ascension

    @property
    def eccentricity(self) -> str:
        """Gets the eccentricity of this TLE.


        :return: The eccentricity of this TLE.
        :rtype: str
        """
        return self._eccentricity

    @eccentricity.setter
    def eccentricity(self, eccentricity: str):
        """Sets the eccentricity of this TLE.


        :param eccentricity: The eccentricity of this TLE.
        :type eccentricity: str
        """

        self._eccentricity = eccentricity

    @property
    def argument_of_perigee(self) -> str:
        """Gets the argument_of_perigee of this TLE.


        :return: The argument_of_perigee of this TLE.
        :rtype: str
        """
        return self._argument_of_perigee

    @argument_of_perigee.setter
    def argument_of_perigee(self, argument_of_perigee: str):
        """Sets the argument_of_perigee of this TLE.


        :param argument_of_perigee: The argument_of_perigee of this TLE.
        :type argument_of_perigee: str
        """

        self._argument_of_perigee = argument_of_perigee

    @property
    def mean_anomaly(self) -> str:
        """Gets the mean_anomaly of this TLE.


        :return: The mean_anomaly of this TLE.
        :rtype: str
        """
        return self._mean_anomaly

    @mean_anomaly.setter
    def mean_anomaly(self, mean_anomaly: str):
        """Sets the mean_anomaly of this TLE.


        :param mean_anomaly: The mean_anomaly of this TLE.
        :type mean_anomaly: str
        """

        self._mean_anomaly = mean_anomaly

    @property
    def revolution_number_at_epoch(self) -> str:
        """Gets the revolution_number_at_epoch of this TLE.


        :return: The revolution_number_at_epoch of this TLE.
        :rtype: str
        """
        return self._revolution_number_at_epoch

    @revolution_number_at_epoch.setter
    def revolution_number_at_epoch(self, revolution_number_at_epoch: str):
        """Sets the revolution_number_at_epoch of this TLE.


        :param revolution_number_at_epoch: The revolution_number_at_epoch of this TLE.
        :type revolution_number_at_epoch: str
        """

        self._revolution_number_at_epoch = revolution_number_at_epoch

    @property
    def checksum_line_2(self) -> str:
        """Gets the checksum_line_2 of this TLE.


        :return: The checksum_line_2 of this TLE.
        :rtype: str
        """
        return self._checksum_line_2

    @checksum_line_2.setter
    def checksum_line_2(self, checksum_line_2: str):
        """Sets the checksum_line_2 of this TLE.


        :param checksum_line_2: The checksum_line_2 of this TLE.
        :type checksum_line_2: str
        """

        self._checksum_line_2 = checksum_line_2

    @property
    def international_designator_piece_of_launch(self) -> str:
        """Gets the international_designator_piece_of_launch of this TLE.


        :return: The international_designator_piece_of_launch of this TLE.
        :rtype: str
        """
        return self._international_designator_piece_of_launch

    @international_designator_piece_of_launch.setter
    def international_designator_piece_of_launch(self, international_designator_piece_of_launch: str):
        """Sets the international_designator_piece_of_launch of this TLE.


        :param international_designator_piece_of_launch: The international_designator_piece_of_launch of this TLE.
        :type international_designator_piece_of_launch: str
        """

        self._international_designator_piece_of_launch = international_designator_piece_of_launch

    @property
    def mean_motion(self) -> str:
        """Gets the mean_motion of this TLE.


        :return: The mean_motion of this TLE.
        :rtype: str
        """
        return self._mean_motion

    @mean_motion.setter
    def mean_motion(self, mean_motion: str):
        """Sets the mean_motion of this TLE.


        :param mean_motion: The mean_motion of this TLE.
        :type mean_motion: str
        """

        self._mean_motion = mean_motion
